i2p-browser 4.05 KB
Newer Older
Kill Your TV's avatar
Kill Your TV committed
1 2 3 4 5 6 7 8 9 10 11 12 13 14
#!/bin/sh

set -e

# This isn't very useful without I2P...
grep -qw "i2p" /proc/cmdline || exit 0

CMD=$(basename ${0})
LOCK=/var/lock/${CMD}

. gettext.sh
TEXTDOMAIN="tails"
export TEXTDOMAIN

15 16
. /usr/local/lib/tails-shell-library/i2p.sh

Kill Your TV's avatar
Kill Your TV committed
17 18 19
CONF_DIR=/var/lib/i2p-browser
COW=${CONF_DIR}/cow
CHROOT=${CONF_DIR}/chroot
20
BROWSER_NAME=i2p-browser
Kill Your TV's avatar
Kill Your TV committed
21 22 23
BROWSER_USER=i2pbrowser
START_PAGE="http://127.0.0.1:7657"

24
# Import the TBB_EXT variable, and guess_best_tor_browser_locale().
25 26
. /usr/local/lib/tails-shell-library/tor-browser.sh

27 28 29
# Import windows_camouflage_is_enabled()
. /usr/local/lib/tails-shell-library/tor-browser.sh

30 31
. /usr/local/lib/tails-shell-library/chroot-browser.sh

Tails developers's avatar
Tails developers committed
32 33
NOSCRIPT_EXT_XPI="${TBB_EXT}/{73a6fe31-595d-460b-a920-fcc0f8843232}.xpi"
TORBUTTON_EXT_DIR="${TBB_EXT}/torbutton@torproject.org"
34
HUMAN_READABLE_NAME="`gettext \"I2P Browser\"`"
35

Kill Your TV's avatar
Kill Your TV committed
36
cleanup () {
37
    try_cleanup_browser_chroot ${CHROOT} ${COW} ${BROWSER_USER}
Kill Your TV's avatar
Kill Your TV committed
38 39
}

40 41 42 43 44 45 46 47 48 49
error () {
    local cli_text="${CMD}: `gettext \"error:\"` ${@}"
    local dialog_text="<b><big>`gettext \"Error\"`</big></b>

${@}"
    echo "${cli_text}" >&2
    sudo -u ${SUDO_USER} zenity --error --title "" --text "${dialog_text}"
    exit 1
}

Kill Your TV's avatar
Kill Your TV committed
50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70
verify_start () {
    # Make sure the user really wants to start the browser in case the router console isn't available
    local dialog_msg="<b><big>`gettext \"Do you still want to launch I2P Browser?\"`</big></b>

`gettext \"The I2P router console is not ready.\"`"
    local launch="`gettext \"_Launch\"`"
    local exit="`gettext \"_Exit\"`"
    # Since zenity can't set the default button to cancel, we switch the
    # labels and interpret the return value as its negation.
    if sudo -u ${SUDO_USER} zenity --question --title "" --ok-label "${exit}" \
       --cancel-label "${launch}" --text "${dialog_msg}"; then
        exit 0
    fi
}

show_start_notification () {
    local title="`gettext \"Starting the I2P Browser...\"`"
    local body="`gettext \"This may take a while, so please be patient.\"`"
    tails-notify-user "${title}" "${body}" 10000
}

71 72 73
copy_extra_tbb_prefs () {
    local chroot="${1}"
    local browser_user="${2}"
74

75 76 77
    local tbb_prefs="/etc/tor-browser/profile/preferences"
    local browser_prefs_dir="${chroot}/home/${browser_user}/.tor-browser"/profile.default/preferences
    mkdir -p "${browser_prefs_dir}"
78
    # Selectively copy the TBB prefs we want
79 80 81 82 83
    sed '/\(security\|update\|download\|spell\|noscript\|torbrowser\|torbutton\)/!d' "${tbb_prefs}"/0000tails.js > \
                    "${browser_prefs_dir}"/0000tails.js
    sed '/\(capability\|noscript\|torbutton\)/!d' "${tbb_prefs}"/extension-overrides.js > \
                    "${browser_prefs_dir}"/extension-overrides.js
    chown -R ${browser_user}:${browser_user} "${browser_prefs_dir}"
Kill Your TV's avatar
Kill Your TV committed
84 85 86 87 88 89 90 91 92 93 94 95 96 97
}

show_shutdown_notification () {
    local title="`gettext \"Shutting down the I2P Browser...\"`"
    local body="`gettext \"This may take a while, and you may not restart the I2P Browser until it is properly shut down.\"`"
    tails-notify-user "${title}" "${body}" 10000
}

# Prevent multiple instances of the script.
exec 9>${LOCK}
if ! flock -x -n 9; then
    error "`gettext \"Another I2P Browser is currently running, or being cleaned up. Please retry in a while.\"`"
fi

98
if ! i2p_router_console_is_ready; then
Kill Your TV's avatar
Kill Your TV committed
99 100 101
    verify_start
fi
show_start_notification
102

103 104 105
echo "* Setting up chroot"
setup_browser_chroot ${CHROOT} ${COW} || \
    error "`gettext \"Failed to setup chroot.\"`"
106

107
echo "* Configuring chroot"
108 109
configure_chroot_dns_servers "${CHROOT}" "127.0.0.1"
configure_chroot_browser "${CHROOT}" "${BROWSER_NAME}" "${BROWSER_USER}" \
110
    "${START_PAGE}" "${TBB_EXT}"/langpack-*.xpi \
111 112 113 114 115 116 117
    "${NOSCRIPT_EXT_XPI}" "${TORBUTTON_EXT_DIR}"
copy_extra_tbb_prefs "${CHROOT}" "${BROWSER_USER}"
BEST_LOCALE="$(guess_best_tor_browser_locale)"
set_chroot_browser_locale "${CHROOT}" "${BROWSER_USER}" "${BEST_LOCALE}"
set_chroot_torbutton_browser_name "${CHROOT}" "${HUMAN_READABLE_NAME}" "${BEST_LOCALE}"
set_chroot_browser_permissions "${CHROOT}" "${BROWSER_USER}"

118 119
echo "* Starting I2P Browser"
run_chroot_browser ${CHROOT} ${BROWSER_USER} ${SUDO_USER}
Kill Your TV's avatar
Kill Your TV committed
120 121 122
show_shutdown_notification

exit 0